/*
	Copyright (C) 2010-2011 OrderStorm, Inc. (e-mail: wordpress-ecommerce@orderstorm.com)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
jQuery
(
	function ()
	{
		var productFeaturesData = jQuery.parseJSON(html_entity_decode(ajaxGlobals.productFeaturesData));
		
		function validateProductFeatures(jsonOrderStormProductFeaturesData, jsonOrderStormProductDetailsFormData)
		{
			var result = 0;
			
			var reFeaturePostVariable = /^feature\[([^\]]*)\].*$/;
			var reResult;
			var message = "";				
			var member;
			var arrFeatureGroupIDs = [];
			var numberOfFeatureGroups;
			var arrFormFeatureGroupIDs = [];
			var numberOfFormFeatureGroups;
			var objFormFeatureGroups = {};
			var blnResult;
			var blnResult2;
			var objFeatureGroupData;
			
			for (member in jsonOrderStormProductFeaturesData)
			{
				arrFeatureGroupIDs.push(member);
			}
			
			numberOfFeatureGroups = arrFeatureGroupIDs.length;
			
			// Find every feature group ID first
			jQuery.each
			(
				jsonOrderStormProductDetailsFormData,
				function(arrayIndex, arrayElement)
				{
					reFeaturePostVariable.lastIndex = 0;
					reResult = reFeaturePostVariable.exec(arrayElement.name);
					if (reResult != null)
					{
						if (jQuery.inArray(reResult[1], arrFormFeatureGroupIDs) === -1)
						{
							arrFormFeatureGroupIDs.push(reResult[1]);
						}
					}
				}
			);
			
			numberOfFormFeatureGroups = arrFormFeatureGroupIDs.length;
			
			if (numberOfFormFeatureGroups <= numberOfFeatureGroups)
			{
				// Now, build an accessible object to put the user-chosen form features in it
				jQuery.each
				(
					arrFormFeatureGroupIDs,
					function(arrayIndex, arrayElement)
					{
						var arrFeatureGroup = [];
						
						objFormFeatureGroups[arrayElement] = arrFeatureGroup;
					}
				);
				
				// Now, populate said object
				jQuery.each
				(
					jsonOrderStormProductDetailsFormData,
					function(arrayIndex, arrayElement)
					{
						reFeaturePostVariable.lastIndex = 0;
						reResult = reFeaturePostVariable.exec(arrayElement.name);
						if (reResult != null)
						{
							objFormFeatureGroups[reResult[1]].push(arrayElement.value);
						}
					}
				);
				
				// Make sure the form feature groups are all valid for the product being added
				blnResult = true;
				jQuery.each
				(
					arrFormFeatureGroupIDs,
					function(arrayIndex, arrayElement)
					{
						if (jQuery.inArray(arrayElement, arrFeatureGroupIDs) === -1)
						{
							blnResult = false;
							return false;
						}
					}
				);
				if (blnResult === false)
				{
					// Some form feature group IS NOT a valid feature group for the product being
					// added
					result = 2;
				}
				else
				{
					// For every product feature group that is marked as required, make sure that
					// at least one product feature is selected from that group
					blnResult = true;
					jQuery.each
					(
						arrFeatureGroupIDs,
						function(arrayIndex, intFeatureGroupID)
						{
							objFeatureGroupData = jsonOrderStormProductFeaturesData[intFeatureGroupID];
							
							if (objFeatureGroupData.feature_group_is_required === true)
							{
								if (jQuery.inArray(intFeatureGroupID, arrFormFeatureGroupIDs) === -1)
								{
									// Some required feature group had NO FEATURE SELECTED from it in the form
									// feature data
									result = 3;
									blnResult = false;
									return false;
								}
								else
								{
									blnResult2 = false;
									jQuery.each
									(
										objFeatureGroupData.features,
										function(featureIndexInGroup, objFeature)
										{
											if (jQuery.inArray(objFeature.feature_product_guid, objFormFeatureGroups[intFeatureGroupID]) > -1)
											{
												blnResult2 = true;
												return false;
											}
										}
									);
									if (blnResult2 === false)
									{
										blnResult = false;
										return false;
									}
								}
							}
						}
					);
					if (blnResult === false)
					{
						// Found a required group for which no VALID feature was selected (there were
						// invalid features selected. CRITICAL ERROR!!!)
						result = 4;
					}
					else
					{
						// For each feature group with a feature display type of "radio", "dropdown" or "colorSelector",
						// verify that ONLY ONE feature is selected for such group
						blnResult = true;
						jQuery.each
						(
							arrFeatureGroupIDs,
							function(arrayIndex, intFeatureGroupID)
							{
								objFeatureGroupData = jsonOrderStormProductFeaturesData[intFeatureGroupID];
								
								if (objFeatureGroupData.feature_display_type === 'radio' || objFeatureGroupData.feature_display_type === 'dropdown' || objFeatureGroupData.feature_display_type === 'colorSelector')
								{
									if (objFormFeatureGroups[intFeatureGroupID].length > 1)
									{
										blnResult = false;
										return false;
									}
								}
							}
						);
						if (blnResult === false)
						{
							// Found more than one selected feature for a feature group with a feature
							// display type of "radio", "dropdown" or "colorSelector"
							result = 5;
						}
						else
						{
							// For required individual features, verify they are selected in the form
							blnResult = true;
							jQuery.each
							(
								arrFeatureGroupIDs,
								function(arrayIndex, intFeatureGroupID)
								{
									objFeatureGroupData = jsonOrderStormProductFeaturesData[intFeatureGroupID];
									
									blnResult2 = true;
									jQuery.each
									(
										objFeatureGroupData.features,
										function(featureIndexInGroup, objFeature)
										{
											if (objFeature.feature_is_required === true)
											{
												if (jQuery.inArray(objFeature.feature_product_guid, objFormFeatureGroups[intFeatureGroupID]) === -1)
												{
													blnResult2 = false;
													return false;
												}
											}
										}
									);
									if (blnResult2 === false)
									{
										blnResult = false;
										return false;
									}
								}
							);
							if (blnResult === false)
							{
								// Found a required individual feature which was NOT selected in the form
								result = 6;
							}
							else
							{
								// Verify all selected form features are valid for the product being
								// added to the cart
								blnResult = true;
								jQuery.each
								(
									arrFormFeatureGroupIDs,
									function(intFormFeatureGroupIndex, intFormFeatureGroupID)
									{
										blnResult2 = true;
										jQuery.each
										(
											objFormFeatureGroups[intFormFeatureGroupID],
											function(intFormFeatureIndex, strFormFeatureProductGUID)
											{
												blnResult3 = false;
												jQuery.each
												(
													jsonOrderStormProductFeaturesData[intFormFeatureGroupID].features,
													function(intFeatureIndexInGroup, objFeatureData)
													{
														if (objFeatureData.feature_product_guid === strFormFeatureProductGUID)
														{
															blnResult3 = true;
															return false;
														}
													}
												);
												if (blnResult3 === false)
												{
													blnResult2 = false;
													return false;
												}
											}
										);
										if (blnResult2 === false)
										{
											blnResult = false;
											return false;
										}
									}
								);
								if (blnResult === false)
								{
									// Some selected form feature IS NOT a valid feature for the
									// product being added
									result = 7;
								}
							}
						}
					}
				}
			}
			else
			{
				// Number of form feature groups IS NOT less than or equal to the number
				// of valid feature groups of the product being added
				result = 1;
			}
			
			return result;
		}
		
		function activateColorPicker(colorPickerIDsuffix)
		{
			jQuery
			(
				function ()
				{
					jQuery("#color-picker-" + colorPickerIDsuffix).colorpicker
					(
						{
							limit:6,
							css:
							{
								container:
								{
									width: "170px",
									height: "24px",
									padding: "10px",
									border: "1px solid #000000",
									backgroundColor: "",
									position: "relative"
								},
								colors:
								{
									width: "32px",
									height: "32px",
									margin: 0,
									padding: 0,
									border: "1px solid #000000"
								}
							},
							callback:function(color, name, guid, group_id)
							{
								jQuery("#selected-color-" + colorPickerIDsuffix).html(name);
								jQuery('input[name="feature[' + colorPickerIDsuffix + ']"]').val(guid);
								osws.canvas.colors[colorPickerIDsuffix] = color;
								refresh_canvas();
							},
							colorList:productFeaturesData[colorPickerIDsuffix]["features"],
							feature_group_name_id: colorPickerIDsuffix
						}
					);
				}
			);
		}
		
		function submitProductDetailsForm(event)
		{
			var orderStormProductDetailsFormData = jQuery('#ostrm_product_details_form').serializeArray();
			var validationResult = validateProductFeatures(productFeaturesData, orderStormProductDetailsFormData);
			
			event.preventDefault();
			
			if (validationResult === 0)
			{
				orderStormProductDetailsFormData.push({"name":"action", "value":"add_to_cart"});
				orderStormProductDetailsFormData.push({"name":"ostrmCartNonce", "value":ajaxGlobals.ostrmCartNonce});
				
				jQuery.ajax
				(
					{
						async:false,
						cache:false,
						contentType:"application/x-www-form-urlencoded",
						data:orderStormProductDetailsFormData,
						dataType:"json",
						error:	function (XMLHttpRequest, textStatus, errorThrown)
								{
									alert('Add failed.\n\ntextStatus = ' + textStatus + '\nerrorThrown = ' + errorThrown);
								},
						processData:true,
						success:	function (data, textStatus)
									{
										if (data.hasOwnProperty('blnAddSuccessful') && data.hasOwnProperty('blnValidNonce'))
										{
											if (data.blnAddSuccessful)
											{
												cartGlobals.orderKeyGUID = data.orderKeyGUID;
												jQuery("#checkoutFrame").trigger('click');
											}
											else
											{
												if (data.blnValidNonce !== true)
												{
													alert('Add failed -> Invalid Nonce.');
													window.location.href = '/';
												}
												else
												{
													alert('Add failed -> Unknown cause.');
												}
											}
										}
										else
										{
											alert('Invalid response.');
										}
									},
						timeout:15000,
						type:"POST",
						url:ajaxGlobals.ajaxURL
					}
				);
			}
			else
			{
				alert("Please select the required options.");
			}
		}
		
		function clear_canvas()
		{
			osws.canvas.colors = [];
			refresh_canvas();
		}
		
		function refresh_canvas()
		{
			osws.canvas.draw_shape('myCanvas');
		}
		
		jQuery.each
		(
			productFeaturesData,
			function (feature_group_name_id, feature_group)
			{
				if (feature_group.hasOwnProperty("feature_display_type"))
				{
					if (feature_group.feature_display_type === "colorSelector")
					{
						activateColorPicker(feature_group_name_id);
					}
				}
			}
		);
		
		if(typeof osws != 'undefined')
		{
			jQuery('#myCanvas').attr("width", osws.canvas.width);
			jQuery('#myCanvas').attr("height", osws.canvas.height);
			refresh_canvas();
		}
		
		jQuery('#ostrm_product_details_form').submit(submitProductDetailsForm);
	}
);
